unit HoverButton;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  THoverButton = class(TBitBtn)
  private
    { Private declarations }
     FOverImage: TBitmap;
     FLeaveImage: TBitmap;
  protected
    { Protected declarations }
    procedure MouseEnter(var Msg: TMessage);
        message cm_mouseEnter;
    procedure MouseLeave(var Msg: TMessage);
        message cm_mouseLeave;
    procedure SetOverImage(bmp: TBitmap);
    procedure SetLeaveImage(bmp: TBitmap);

  public
    { Public declarations }
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
  published
    { Published declarations }
    property Cursor;
    property OverImage: TBitmap
        read FOverImage write SetOverImage;
    property LeaveImage: TBitmap
        read FLeaveImage write SetLeaveImage;

  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('ARIOX.COM', [THoverButton]);
end;

constructor THoverButton.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);                           { ALWAYS do this first! }
   self.Cursor := crHandPoint;
   FOverImage:= TBitmap.Create();
   FLeaveImage:=TBitmap.Create();
end;

destructor THoverButton.Destroy;
begin
    FOverImage.Free;
    FLeaveImage.Free;
    inherited Destroy;
end;

procedure THoverButton.MouseEnter(var Msg: TMessage);
begin
    if Assigned(FOverImage) then
    self.Glyph.Assign(FOverImage);
end;
procedure THoverButton.MouseLeave(var Msg: TMessage);
begin
    if Assigned(FLeaveImage) then
    self.Glyph.Assign(FLeaveImage);
end;

procedure THoverButton.SetLeaveImage(bmp: TBitmap);
begin
    FLeaveImage.Assign(bmp);
    self.Glyph.Assign(bmp);
    self.Height := bmp.Height + 7;
    self.Width := 125;
end;

procedure THoverButton.SetOverImage(bmp: TBitmap);
begin
    FOverImage.Assign(bmp);
end;

end.
