unit MixedStatusBar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls;

type
  TMixedStatusBar = class(TStatusBar)
  private
    { Private declarations }
    pb: TProgressBar;
    sp: TStatusPanel;
    FMin: Integer;
    FMax: Integer;
    FPosition: Integer;
    FText: String;


  protected
    { Protected declarations }
    procedure SetMin(value: Integer);
    procedure SetMax(value: Integer);
    procedure SetPosition(value: Integer);
    procedure SetString(value: String);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property Min: Integer
        read FMin write SetMin;
    property Max: Integer
        read FMax write SetMax;
    property Position: Integer
        read FPosition write SetPosition;
    property Text: String
        read FText write SetString;

    end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('ARIOX.COM', [TMixedStatusBar]);
end;

constructor TMixedStatusBar.Create(AOwner: TComponent);     { this goes after implementation }
begin
  inherited Create(AOwner);                           { ALWAYS do this first! }
  self.Panels.Add();
  self.Panels.Add();
  self.SimplePanel := false;
  sp := self.Panels.Items[0];
  sp.Bevel := pbNone;
  sp.Width := 150;
  pb := TProgressBar.Create(self);
  pb.Parent := self;
  pb.Height := self.Height-3 ;
  pb.Width := sp.Width-2;
  pb.BorderWidth := 0;
  pb.Left := (sp.Width - pb.Width) div 2;
  pb.Top := ((self.Height - pb.Height ) div 2)+ 1 ;
  pb.Visible := true;
  pb.Position := pb.Min;


end;

destructor TMixedStatusBar.Destroy;

begin
  pb.Free;
  inherited Destroy;
end;

procedure TMixedStatusBar.SetMin(value: Integer);
begin
   pb.Min := value;
   FMin := value;
end;

procedure TMixedStatusBar.SetMax(value: Integer);
begin
   pb.Max := value;
   FMax:= value;
end;

procedure TMixedStatusBar.SetPosition(value: Integer);
begin
   if (value >= pb.Min) and (value <= pb.Max) then
   begin
        pb.Position := value;
        FPosition:= value;
   end
   else
   begin
        Beep;
        Application.MessageBox('Value entered is not valid', 'Illegal value', MB_ICONSTOP);
   end;     

end;


procedure TMixedStatusBar.SetString(value: String);
begin
        self.Panels.Items[1].Text := value;
        FText := value;
end;

end.
