unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ImgList, ComCtrls, SortedListView, MixedStatusBar, NetworkPrinter;

type
  TForm1 = class(TForm)
    MixedStatusBar1: TMixedStatusBar;
    SortedListView1: TSortedListView;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    AddItems1: TMenuItem;
    Print1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    NetworkPrinter1: TNetworkPrinter;
    procedure AddItems1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure NetworkPrinter1JobCompleted(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.AddItems1Click(Sender: TObject);
var
    item: TListItem;
begin
    MixedStatusBar1.Min := 0;
    MixedStatusBar1.Max := 2;
    MixedStatusBar1.Position := 0;
    item := SortedListView1.Items.Add;
    item.ImageIndex := -1;
    item.Caption := 'Alexis Rios';
    item.SubItems.Add('777-7777');
    MixedStatusBar1.Position :=   MixedStatusBar1.Position + 1;

    item := SortedListView1.Items.Add;
    item.ImageIndex := -1;
    item.Caption := 'Wil Smith';
    item.SubItems.Add('111-1111');
    MixedStatusBar1.Position :=   MixedStatusBar1.Position + 1;
end;

procedure TForm1.Print1Click(Sender: TObject);
var
    i: Integer;
    currentLine: Integer;
    bmp: TBitmap;
    r: TRect;
    p: TPoint;
begin
if NetworkPrinter1.SelectPrinter then
begin
   NetworkPrinter1.Font.Name := 'Arial';
   NetworkPrinter1.Font.Size := 12;
   NetworkPrinter1.SetSettings(); //Must be called before printing
   NetworkPrinter1.Title := 'Printing Example';
   NetworkPrinter1.BeginDoc;
   NetworkPrinter1.SetBoldFont;
   NetworkPrinter1.WriteData(1,1, 'My Report');
   NetworkPrinter1.WriteData(NetworkPrinter1.CharsPerLine - 10, 1, Format('Page %d',[NetworkPrinter1.CurrentPage]));
   NetworkPrinter1.SetRegularFont;
   currentLine := 3;
   for i := 0 to Pred(SortedListView1.Items.Count) do
   begin
        if currentLine > NetworkPrinter1.LinesPerPage then
        begin
            NetworkPrinter1.NewPage();
            NetworkPrinter1.WriteData(1,1, 'My Report');
            NetworkPrinter1.WriteData(NetworkPrinter1.CharsPerLine - 10, 1, Format('Page %d',[NetworkPrinter1.CurrentPage]));
            currentLine := 3;
        end;
        NetworkPrinter1.WriteData(1, currentLine, SortedListView1.Items.Item[i].Caption);
        Inc(currentLine);
   end;
   NetworkPrinter1.NewPage();

   //Draw a bitmap at the last page
   bmp := TBitmap.Create();
   bmp.LoadFromFile('C:\Winnt\winnt.bmp');
   p.x := 1;
   p.y := 1;
   r.TopLeft := p;
   p.x := 1000;
   p.y := 500;
   r.BottomRight := p;
   NetworkPrinter1.DrawImage(r, bmp);
   bmp.Free();
   NetworkPrinter1.EndDoc;
end;
end;

procedure TForm1.NetworkPrinter1JobCompleted(Sender: TObject);
begin
MessageBox(0, 'Print job was sent to printer', 'Printing', MB_ICONINFORMATION);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
SortedListView1.SetImages;
end;

end.
