unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Jpeg, Inifiles, ShellApi, Torrybtn, Menus,
  BarPopupMenu, CoolTrayIcon, PBFolderDialog;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    SaveDialog1: TSaveDialog;
    Timer1: TTimer;
    Shape1: TShape;
    SaveDialog2: TSaveDialog;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    CoolButton1: TTorryButton;
    CoolButton2: TTorryButton;
    CoolButton3: TTorryButton;
    CoolTrayIcon1: TCoolTrayIcon;
    BarPopupMenu1: TBarPopupMenu;
    Exit1: TMenuItem;
    Capture1: TMenuItem;
    Timercapture1: TMenuItem;
    Settings1: TMenuItem;
    N1: TMenuItem;
    Timer2: TTimer;
    FolderDialog1: TPBFolderDialog;
    Timer3: TTimer;
    Timer4: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CoolButton2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure CoolButton3Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure Label4Click(Sender: TObject);
    procedure CoolButton1Click(Sender: TObject);
    procedure Label5Click(Sender: TObject);
    procedure Label1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CoolTrayIcon1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Capture1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timercapture1Click(Sender: TObject);
    procedure Settings1Click(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Timer4Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  b:Byte;
  Set_Pipnout: Boolean;
  Set_Jpeg: Boolean;
  Set_Timer: Integer;
  Set_Prev: Boolean;
  Set_Prev_Height: Integer;
  Set_Prev_Width: Integer;
  Set_UseIcon: Boolean;
  Set_AlwaysMin: Boolean;
  Set_AutoSave: Boolean;
  Set_Folder: String;
  Set_UsePrnScr: Boolean;
  Set_CaptOnlyWindow: Boolean; //v4
  Set_Monitor: Integer; //v4
  ini: TIniFile;
  path,inipath:String;
  minimized:Boolean;
  willcapture: Boolean;
  scrlockstatus, scrlockbefore: SmallInt;

const kSC_DragMove = $F012 ;

implementation

uses Unit2, Unit3, Math;

{$R *.DFM}

function GetAppPath :string;
var
 x, y :string;
begin
 x := ParamStr(0);
 y := ExtractFileName(ParamStr(0));
 Result := copy(x,0,length(x) - length(y));
end;

procedure TForm1.FormCreate(Sender: TObject);
var R: HRgn;
begin
 form1.width := 200;                       // nastav ku formu na 200
 form1.height := 250;              // nastaven tvercovho formu
 R := CreateEllipticRgn(0,0,width,height); // nastav velikost elipsy
 SetWindowRgn(Handle,R,True);              // aplikuje elipsu na form
 Label1.caption:='  My Advanced'+#13+'Screen Capture';
 path:=GetAppPath;
 inipath:=path+'settings.ini';
 ini := TIniFile.Create(inipath);
 try
   Set_pipnout := ini.ReadBool('Settings','beep',true);
   Set_Jpeg := ini.ReadBool('Settings','jpeg',true);
   Set_Timer := ini.ReadInteger('Settings','timer',3);
   Set_Prev := ini.ReadBool('Settings','prev',true);
   Set_Prev_Width := ini.ReadInteger('Settings','width',320);   
   Set_Prev_Height := ini.ReadInteger('Settings','height',240);
   minimized := ini.ReadBool('Settings','minimized',False);
   Set_UseIcon := ini.ReadBool('Settings','icon',True);
   Set_AlwaysMin := ini.ReadBool('Settings','alwaysmin',False);
   Set_AutoSave := ini.ReadBool('Settings','autosave',False);
   Set_Folder := ini.ReadString('Settings','folder','');
   Set_UsePrnScr := ini.ReadBool('Settings','prnscr',True);
   Set_CaptOnlyWindow := ini.ReadBool('Settings','onlywnd',False); //v4
   Set_Monitor := ini.ReadInteger('Settings','monitor',0); //v4
 finally
   ini.Free;
 end;

   If Set_AlwaysMin then minimized := True;
   If not Set_UseIcon then minimized := False;
   If not Set_UsePrnScr then Timer4.enabled := False; 
   FolderDialog1.Folder := Set_Folder;

end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 ReleaseCapture(); // obnov windowsovsk 'mouse input procesing'
 Form1.Perform(WM_SYSCOMMAND, kSC_DragMove, 0); //pesune panel
end;

procedure TForm1.CoolButton2Click(Sender: TObject);
begin
b:=1;
Application.minimize;
ShowWindow(Application.Handle, SW_HIDE);
Timer1.enabled:=True;
end;

function SearchFreeFile(Typ, Folder: String):String;
var
fpos: Integer;
f: Text;
str: String;
ok: Boolean;
begin
fpos:=0;
ok:=False;
repeat
Inc(fpos);
If fpos<10 then str:=Set_Folder+'\'+'0000000'+IntToStr(fpos)+typ else
If fpos<100 then str:=Set_Folder+'\'+'000000'+IntToStr(fpos)+typ else
If fpos<1000 then str:=Set_Folder+'\'+'00000'+IntToStr(fpos)+typ else
If fpos<10000 then str:=Set_Folder+'\'+'0000'+IntToStr(fpos)+typ else
If fpos<100000 then str:=Set_Folder+'\'+'000'+IntToStr(fpos)+typ else
If fpos<1000000 then str:=Set_Folder+'\'+'00'+IntToStr(fpos)+typ else
If fpos<10000000 then str:=Set_Folder+'\'+'0'+IntToStr(fpos)+typ else
If fpos<100000000 then str:=Set_Folder+'\'+IntToStr(fpos)+typ else
If fpos=100000000 then Begin Result:=''; Exit; End;

AssignFile(f,str);
{$i-}
Reset(f);
{$i+}
If IOResult = 0 then ok := False else ok := True;
If not ok then CloseFile(F);
until ok;
Result := str;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
DesktopBitmap, DesktopPrev: Tbitmap;
MyJPEG : TJPEGImage;
DC: HDC;
DesktopWnd: HWND;
Frequency, Duration: Integer;
FName: String;
aRect: TRect; //v4
begin
case b of
1..50: begin
If Set_Pipnout then
begin
frequency:=800;
duration:=1;
if Win32Platform = VER_PLATFORM_WIN32_NT then
    Windows.Beep(Frequency, Duration)
  else
    asm  MOV ECX, Frequency
         JCXZ @@2
         MOV EAX, 1193181
         CDQ
         IDIV ECX
         MOV ECX, EAX
         IN AL, ($61)
         TEST AL, $03
         JNZ @@1
         OR AL, $03
         OUT ($61), AL
         MOV AL, $B6
         OUT ($43), AL
    @@1: MOV AL, CL
         OUT ($42), AL
         MOV AL, CH
         OUT ($42), AL
         PUSH Duration
         CALL Windows.Sleep
    @@2: IN AL, ($61)
         AND AL, $FC
         OUT ($61), AL
    end;
end;
Inc(b);
If b=Set_Timer then b:=250;
   end;

250: begin
    Timer1.enabled:=False;
If Set_Pipnout then
begin
frequency:=1000;
duration:=1;
if Win32Platform = VER_PLATFORM_WIN32_NT then
    Windows.Beep(Frequency, Duration)
  else
    asm  MOV ECX, Frequency
         JCXZ @@2
         MOV EAX, 1193181
         CDQ
         IDIV ECX
         MOV ECX, EAX
         IN AL, ($61)
         TEST AL, $03
         JNZ @@1
         OR AL, $03
         OUT ($61), AL
         MOV AL, $B6
         OUT ($43), AL
    @@1: MOV AL, CL
         OUT ($42), AL
         MOV AL, CH
         OUT ($42), AL
         PUSH Duration
         CALL Windows.Sleep
    @@2: IN AL, ($61)
         AND AL, $FC
         OUT ($61), AL
    end;
end;
    b:=1;

    DesktopBitmap := TBitmap.Create;        //vytvo DesktopBitmap jako Tbitmap
    If Set_CaptOnlyWindow then
    begin
      DesktopWnd := GetForegroundWindow;         // zjisti handle okna   //v4
      GetWindowRect(DesktopWnd,aRect);   // zjisti rozmery okna     //v4
      DesktopBitmap.Width := aRect.Right - aRect.Left;    // nastav ku bitmapy na ku okna        //v4
      DesktopBitmap.Height := aRect.Bottom - aRect.Top;  // nastav vku bitmapy na vku okna      //v4

      DC := GetWindowDC(DesktopWnd);          // zjiti handle okna
      BitBlt(DesktopBitmap.Canvas.Handle, 0, 0, aRect.Right - aRect.Left, aRect.Bottom - aRect.Top, DC, 0, 0, SrcCopy);
      ReleaseDC(DesktopWnd, DC);              // uvolni DC
    end
    else
    begin
      DesktopBitmap.Width := Screen.Monitors[0].Width;    // nastav ku bitmapy na ku screenu
      if Set_Monitor > 0 then
      begin
        DesktopBitmap.Width := DesktopBitmap.Width + Screen.Monitors[1].Width;
      end;
      if Set_Monitor > 1 then
      begin
        DesktopBitmap.Width := DesktopBitmap.Width + Screen.Monitors[2].Width;
      end;
      if Set_Monitor > 2 then
      begin
        DesktopBitmap.Width := DesktopBitmap.Width + Screen.Monitors[3].Width;
      end;
      if Set_Monitor > 3 then
      begin
        DesktopBitmap.Width := DesktopBitmap.Width + Screen.Monitors[4].Width;
      end;
      if Set_Monitor > 4 then
      begin
        DesktopBitmap.Width := DesktopBitmap.Width + Screen.Monitors[5].Width;
      end;
      if Set_Monitor > 5 then
      begin
        DesktopBitmap.Width := DesktopBitmap.Width + Screen.Monitors[6].Width;
      end;
      if Set_Monitor > 6 then
      begin
        DesktopBitmap.Width := DesktopBitmap.Width + Screen.Monitors[7].Width;
      end;
      if Set_Monitor > 7 then
      begin
        DesktopBitmap.Width := DesktopBitmap.Width + Screen.Monitors[8].Width;
      end;
      if Set_Monitor > 8 then
      begin
        DesktopBitmap.Width := DesktopBitmap.Width + Screen.Monitors[9].Width;
      end;

      DesktopBitmap.Height := Screen.Monitors[0].Height;  // nastav vku bitmapy na vku screenu
      if Set_Monitor > 0 then
      begin
        DesktopBitmap.Height := Max(DesktopBitmap.Height,Screen.Monitors[1].Height);
      end;
      if Set_Monitor > 1 then
      begin
        DesktopBitmap.Height := Max(DesktopBitmap.Height,Screen.Monitors[2].Height);
      end;
      if Set_Monitor > 2 then
      begin
        DesktopBitmap.Height := Max(DesktopBitmap.Height,Screen.Monitors[3].Height);
      end;
      if Set_Monitor > 3 then
      begin
        DesktopBitmap.Height := Max(DesktopBitmap.Height,Screen.Monitors[4].Height);
      end;
      if Set_Monitor > 4 then
      begin
        DesktopBitmap.Height := Max(DesktopBitmap.Height,Screen.Monitors[5].Height);
      end;
      if Set_Monitor > 5 then
      begin
        DesktopBitmap.Height := Max(DesktopBitmap.Height,Screen.Monitors[6].Height);
      end;
      if Set_Monitor > 6 then
      begin
        DesktopBitmap.Height := Max(DesktopBitmap.Height,Screen.Monitors[7].Height);
      end;
      if Set_Monitor > 7 then
      begin
        DesktopBitmap.Height := Max(DesktopBitmap.Height,Screen.Monitors[8].Height);
      end;
      if Set_Monitor > 8 then
      begin
        DesktopBitmap.Height := Max(DesktopBitmap.Height,Screen.Monitors[9].Height);
      end;

      DesktopWnd := GetDesktopWindow;         // zjiti wokno plochy

      DC := GetWindowDC(DesktopWnd);          // zjiti handle wokna plochy
      BitBlt(DesktopBitmap.Canvas.Handle, 0, 0, DesktopBitmap.Width, DesktopBitmap.Height, GetDC(GetDesktopWindow), 0, 0, SrcCopy);
      ReleaseDC(DesktopWnd, DC);              // uvolni DC
    end;

 If Set_Prev then
  If not Set_AutoSave then
  begin
    DesktopPrev := TBitmap.Create;
   try
     DesktopPrev.Width := Set_Prev_Width;
     DesktopPrev.Height := Set_Prev_Height;
     DesktopPrev.Canvas.StretchDraw(Rect(0, 0, Set_Prev_Width, Set_Prev_Height), DesktopBitmap);
     Form3.Image1.Picture.Assign(DesktopPrev);
   finally
     DesktopPrev.Free;
   end;
    Form3.Left:=0;
    Form3.Top:=0;
    Form3.Width:=Set_Prev_Width+10;
    Form3.Height:=Set_Prev_Height+10;
    Form3.Image1.Width:=Set_Prev_Width;
    Form3.Image1.Height:=Set_Prev_Height;
    Form3.Show;
  end;
If Set_Jpeg then
begin
    MyJPEG := TJPEGImage.Create;            // vytvo tJepegImage
    MyJPEG.Assign(DesktopBitmap);                   // pipoj MyBmp k MyJpg
    ShowWindow(Application.Handle, SW_SHOW);
    If not minimized then Application.Restore;
    If Set_AutoSave then
    begin
     If Set_Folder='' then
      begin
       ShowMessage('ERROR: You must select save path first !');
       If minimized then ShowWindow(Application.Handle, SW_HIDE);
      end
      else
      begin
       FName := SearchFreeFile('.jpg',Set_Folder);
       If FName='' then ShowMessage('ERROR: Save failed !');
       try
        If FName <> '' then MyJPEG.SaveToFile(FName);
       except
        ShowMessage('ERROR: Save failed !');
       end;
       If minimized then ShowWindow(Application.Handle, SW_HIDE);       
      end;
    end
    else
    begin
    If SaveDialog1.Execute then MyJPEG.SaveToFile(SaveDialog1.FileName);
    end;
    DesktopBitmap.free;                          // uvoln MyBmp z pamti
    MyJPEG.free;                                // uvoln MyJpg z pamti
   If Set_Prev then Form3.Hide;
end
else
 begin
   ShowWindow(Application.Handle, SW_SHOW);
   If not minimized then Application.Restore;
    If Set_AutoSave then
    begin
     If Set_Folder='' then
      begin
       ShowMessage('ERROR: You must select save path first !');
       If minimized then ShowWindow(Application.Handle, SW_HIDE);
      end
      else
      begin
       FName := SearchFreeFile('.bmp',Set_Folder);
       If FName='' then ShowMessage('ERROR: Save failed !');
       try
        If FName <> '' then DesktopBitmap.SaveToFile(FName);
       except
        ShowMessage('ERROR: Save failed !');
       end;
       If minimized then ShowWindow(Application.Handle, SW_HIDE);
      end;
    end
    else
    begin
    If SaveDialog2.Execute then DesktopBitmap.SaveToFile(SaveDialog2.FileName);
    end;

   DesktopBitmap.free;
  If Set_Prev then Form3.Hide;
 end;

   end;
end; {Of Case}
end;

procedure TForm1.CoolButton3Click(Sender: TObject);
begin
 Form1.Hide;
 Form2.Left:=Form1.Left;
 Form2.Top:=Form1.Top;
 Form2.Show;
end;

procedure TForm1.Label2Click(Sender: TObject);
begin
Application.minimize;
If Set_UseIcon then minimized := True;

 path:=GetAppPath;
 inipath:=path+'settings.ini';
 ini := TIniFile.Create(inipath);
 try
   ini.WriteBool('Settings','minimized',minimized);
 finally
   ini.Free;
 end;

end;

procedure TForm1.Label3Click(Sender: TObject);
begin
 Form1.Close;
end;

procedure TForm1.Label4Click(Sender: TObject);
begin
 ShellExecute(0, 'Open', pChar('http://www.rames.info'), nil, nil, sw_ShowNormal);
end;

procedure TForm1.CoolButton1Click(Sender: TObject);
begin
b:=250;
Application.minimize;
ShowWindow(Application.Handle, SW_HIDE);
Timer1.enabled:=True;
end;
                               
procedure TForm1.Label5Click(Sender: TObject);
var str:String;
begin
 str:=GetAppPath+'readme.txt';
 if ShellExecute(0, 'Open', pChar(str), nil, nil, sw_ShowNormal) < 32 then MessageDlg('Missing file readme.txt !', mtError, [mbOK], 0);
end;

procedure TForm1.Label1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 ReleaseCapture(); // obnov windowsovsk 'mouse input procesing'
 Form1.Perform(WM_SYSCOMMAND, kSC_DragMove, 0); //pesune panel
end;

procedure TForm1.CoolTrayIcon1Click(Sender: TObject);
begin
 Timer3.enabled := True;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 Form1.Close;
end;

procedure TForm1.Capture1Click(Sender: TObject);
begin
If Timer3.enabled = True Then Timer3.enabled := False;
b:=250;
If not minimized then Application.minimize;
If not minimized then ShowWindow(Application.Handle, SW_HIDE);
Timer1.enabled:=True;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
Timer2.enabled := False;
If minimized then Application.minimize;
end;

procedure TForm1.Timercapture1Click(Sender: TObject);
begin
b:=1;
If not minimized then Application.minimize;
If not minimized then ShowWindow(Application.Handle, SW_HIDE);
Timer1.enabled:=True;
end;

procedure TForm1.Settings1Click(Sender: TObject);
begin
If not minimized then
begin
 Form1.Hide;
 Form2.Left:=Form1.Left;
 Form2.Top:=Form1.Top;
 Form2.Show;
end
else
begin
 Form2.Left:=Form1.Left;
 Form2.Top:=Form1.Top;
 Form2.Show;
end;

end;

procedure TForm1.Timer3Timer(Sender: TObject);
begin
Timer3.enabled := False;
If minimized then
begin
 Application.Restore;
 minimized := False;

 path:=GetAppPath;
 inipath:=path+'settings.ini';
 ini := TIniFile.Create(inipath);
 try
   ini.WriteBool('Settings','minimized',minimized);
 finally
   ini.Free;
 end;
end
else
begin
 Application.Minimize;
 minimized := True;

 path:=GetAppPath;
 inipath:=path+'settings.ini';
 ini := TIniFile.Create(inipath);
 try
   ini.WriteBool('Settings','minimized',minimized);
 finally
   ini.Free;
 end;
end;

end;

procedure TForm1.Timer4Timer(Sender: TObject);
begin
 scrlockstatus := GetKeyState(VK_SNAPSHOT);
 If scrlockstatus = scrlockbefore then Exit
  else
   begin
    scrlockbefore := scrlockstatus;
    If scrlockstatus >= 0 then
     begin
      If not willcapture then willcapture:=True;
      Exit
     end
     else
     begin
      If willcapture then willcapture:=False;
      b:=250;
      If not minimized then Application.minimize;
      If not minimized then ShowWindow(Application.Handle, SW_HIDE);
      Timer1.enabled:=True;
     end;
   end;
end;

end.
